
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>UWP开发细节记录：加载图像文件到D2D位图和D3D纹理 / 憋错料</title>

    <meta name="description" content="UWP开发细节记录：加载图像文件到D2D位图和D3D纹理 在UWP中加载文件一般先创建 StorageFile 对象,然后调用StorageFile.OpenReadAsync 方法得到一个IRandomAccessStream 接口用来读取数据: 1 StorageFile image_file = await StorageFile.GetFileFromApplicationUriAsync(new Uri(&quot;ms-appx:///Assets/sample.jpg&quot;, UriKind.Absolute)); 2 IRando ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">UWP开发细节记录：加载图像文件到D2D位图和D3D纹理</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>在UWP中加载文件一般先创建&nbsp;StorageFile 对象，然后调用StorageFile.OpenReadAsync 方法得到一个IRandomAccessStream 接口用来读取数据：</p>
<pre>1 StorageFile image_file = await StorageFile.GetFileFromApplicationUriAsync(new Uri("ms-appx:///Assets/sample.jpg", UriKind.Absolute));
2 IRandomAccessStream stream = await image_file.OpenReadAsync();</pre>
<p>从一个&nbsp;IRandomAccessStream 流开始，加载图像的步骤（C++ /CX实现）：</p>
<p>1. 转换&nbsp;IRandomAccessStream^ 到 ISream 接口：</p>
<pre>1 ComPtr&lt;IStream&gt; source_stream;
2 DX::ThrowIfFailed(::CreateStreamOverRandomAccessStream(stream, IID_PPV_ARGS(&amp;source_stream)));</pre>
<p>2. 调用&nbsp;IWICImagingFactory::CreateDecoderFromStream 方法（假设IWICImagingFactory对象以创建）创建&nbsp;IWICBitmapDecoder 对象用于图像解码，并最终得到&nbsp;IWICFormatConverter 对象转换为适合D2D/D3D的位图格式：</p>
<pre>ComPtr&lt;IWICBitmapDecoder&gt; decoder;
DX::ThrowIfFailed(_device_resources-&gt;GetWicImagingFactory()-&gt;CreateDecoderFromStream(source_stream.Get(), nullptr, WICDecodeMetadataCacheOnDemand, &amp;decoder));

ComPtr&lt;IWICBitmapFrameDecode&gt; frame;
DX::ThrowIfFailed(decoder-&gt;GetFrame(0, &amp;frame));

// Convert the image to a pixel format supported by Direct2D. 32bppPBGRA is guaranteed to be supported on all hardware.
ComPtr&lt;IWICFormatConverter&gt; covert;
DX::ThrowIfFailed(_device_resources-&gt;GetWicImagingFactory()-&gt;CreateFormatConverter(&amp;covert));
DX::ThrowIfFailed(covert-&gt;Initialize(frame.Get(), GUID_WICPixelFormat32bppPBGRA, WICBitmapDitherTypeNone, nullptr, 0.0f, WICBitmapPaletteTypeCustom));</pre>
<p>3. 如果图像用于 D2D ，现在就可以直接用&nbsp;ID2D1DeviceContext::CreateBitmapFromWicBitmap 方法创建 D2D 位图了：</p>
<pre>ComPtr&lt;ID2D1Bitmap1&gt; d2d_bitmap;
DX::ThrowIfFailed(_device_resources-&gt;GetD2DDeviceContext()-&gt;CreateBitmapFromWicBitmap(covert.Get(), &amp;d2d_bitmap));</pre>
<p>4. 如果要用于 D3D 则需要先创建 D3D 纹理：</p>
<pre>// 创建D3D纹理用于3D渲染
D3D11_TEXTURE2D_DESC tex_desc = { 0 };
tex_desc.ArraySize = 1;
tex_desc.BindFlags = D3D11_BIND_RENDER_TARGET | D3D11_BIND_SHADER_RESOURCE;
tex_desc.CPUAccessFlags = 0;
tex_desc.Format = DXGI_FORMAT_B8G8R8A8_UNORM;
tex_desc.Height = height;
tex_desc.Width = width;
tex_desc.MipLevels = 1;
tex_desc.MiscFlags = 0;
tex_desc.SampleDesc.Count = 1;
tex_desc.SampleDesc.Quality = 0;
tex_desc.Usage = D3D11_USAGE_DEFAULT;

ComPtr&lt;ID3D11Texture2D&gt; image_texture;
DX::ThrowIfFailed(_device_resources-&gt;GetD3DDevice()-&gt;CreateTexture2D(&amp;tex_desc, NULL, &amp;image_texture));</pre>
<p>5. 从&nbsp;ID3D11Texture2D 对象中获取&nbsp;IDXGISurface 接口，D2D和D3D只能通过DXGI进行交互：</p>
<pre>ComPtr&lt;IDXGISurface&gt; dxgi_surface;
DX::ThrowIfFailed(image_texture.As(&amp;dxgi_surface));</pre>
<p>6. 通过 ID2D1Factory::CreateDxgiSurfaceRenderTarget 方法创建 D2D 渲染目标：</p>
<pre>float dpiX = 1.0f;
float dpiY = 1.0f;
_device_resources-&gt;GetD2DFactory()-&gt;GetDesktopDpi(&amp;dpiX, &amp;dpiY);

D2D1_RENDER_TARGET_PROPERTIES props = D2D1::RenderTargetProperties(
            D2D1_RENDER_TARGET_TYPE_DEFAULT,
            D2D1::PixelFormat(DXGI_FORMAT_B8G8R8A8_UNORM, D2D1_ALPHA_MODE_PREMULTIPLIED),
            dpiX,
            dpiY
            );

ComPtr&lt;ID2D1RenderTarget&gt; render_target;
DX::ThrowIfFailed(_device_resources-&gt;GetD2DFactory()-&gt;CreateDxgiSurfaceRenderTarget(dxgi_surface.Get(), props, &amp;render_target));</pre>
<p>7. 通过&nbsp;ID2D1RenderTarget::CreateBitmapFromWicBitmap 方法创建位图（注意这里不能直接使用第3步创建的位图，是不同的渲染目标，设备相关的位图不能通用）：</p>
<pre>ComPtr&lt;ID2D1Bitmap&gt; bitmap;
DX::ThrowIfFailed(render_target-&gt;CreateBitmapFromWicBitmap(covert.Get(), &amp;bitmap));</pre>
<p>8. 绘制位图到渲染目标，实际上也是绘制到 D3D 纹理：</p>
<pre>render_target-&gt;BeginDraw();
render_target-&gt;DrawBitmap(bitmap.Get());
render_target-&gt;EndDraw();</pre>
<p>参考：MSDN <a href="https://msdn.microsoft.com/zh-cn/library/dd370966(v=vs.85).aspx" rel="external nofollow noreferrer">《Direct2D 和 Direct3D 互操作性概述》</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-01-31 08:39:37 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>UWP开发细节记录：加载图像文件到D2D位图和D3D纹理的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4AR8GdM.html" rel="bookmark">UWP开发细节记录：判断文件类型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				StorageFile.ContentType 属性,是 string 类型,用来表示文件内容的 MIME 类型.例如,音乐文件可能有 &quot;audio/mpeg&quot; MIME 类型.(MSDN) MIME 类型的定义可以下面的链接找到: MIME Types - http://blogs.msdn.com/b/jaimer/archive/2008/01/04/mime-types.aspx MIME 参考手册 - http://www.w3school.com.cn/media/medi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBnnrYM.html" rel="bookmark">UWP开发细节记录：DirectX&colon;&colon;XMMATRIX 的坑</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这两天写的代码概率性的崩溃在 XMMatrixMultiply() 函数,XMMatrixMultiply() 本身是 inline 函数可以看到崩溃处的代码: vX = _mm_mul_ps(vX,M2.r[0]); 经查,_mm_mul_ps 是 SSE2 指令要求内存地址 16 字节对齐.猜想可能是字节未对齐引发的问题,打印出矩阵参数的地址,果然,发生崩溃时都是未对齐到 16 字节的情况. XMMATRIX 声明中指定了对齐到 16 字节,如下: __declspec(align(16))			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/416zrvM.html" rel="bookmark">从零开始实现ASP&period;NET Core MVC的插件式开发&lpar;六&rpar; - 如何加载插件引用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				标题:从零开始实现ASP.NET Core MVC的插件式开发(六) - 如何加载插件引用. 作者:Lamond Lu 地址:https://www.cnblogs.com/lwqlun/p/11717254.html 源代码:https://github.com/lamondlu/DynamicPlugins 前景回顾 从零开始实现ASP.NET Core MVC的插件式开发(一) - 使用Application Part动态加载控制器和视图 从零开始实现ASP.NET Core MVC的插件			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDda8wM.html" rel="bookmark">hive--udf函数（开发-4种加载方式）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				h2 { color: #fff; background-color: #7CCD7C; padding: 3px; margin: 10px 0px } h3 { color: #fff; background-color: #008eb7; padding: 3px; margin: 10px 0px } UDF函数开发 标准函数(UDF):以一行数据中的一列或者多列数据作为参数然后返回解雇欧式一个值的函数,同样也可以返回一个复杂的对象,例如array,map,struct. 聚合函数(UD			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/j4NxG60.html" rel="bookmark">Django开发模式会加载两次settings文件导致RotatingFileHandlerError</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				当使用RotatingFileHandler作为django的日志处理器的时候,会报: Traceback (most recent call last): File &quot;C:\Python27\lib\logging\handlers.py&quot;, line 78, in emit self.doRollover() File &quot;C:\Python27\lib\logging\handlers.py&quot;, line 141, in doRollover os.rename			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3r5bX10.html" rel="bookmark">iOS开发中懒加载的使用和限制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.在开发过程中很多时候,很多控件和对象需要alloc为了,提高开发效率使得懒加载得以产生. 2.下边用代码解释: 1 - (NSMutableArray *)newsArr{ 2 if (!_newsArr) { 3 self.newsArr = [NSMutableArray array];//1 4 5 // 2. _newsArr = [[NSMutableArray alloc]init]; 6 7 // 3. _newsArr = [NSMutableArray array]; 8			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0RB6750.html" rel="bookmark">Windows Store App JavaScript 开发：页面加载</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  在开发基于JavaScript的Windows应用商店应用时,可以使用HtmlControl和PageControl控件加载一个页面,这两个WinJS库控件曾在上面的内容中提到过,HtmlControl控件接收一个包含页面地址的对象作为参数,并根据这个地址加载相应的页面:PageControl控件是自定义控件,可以使用WinJS.UI.Pages.define函数将一个页面定义为PageControl控件,然后在其他页面中使用,使用这个PageControl控件就相当于加载了该控件相对应的页			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0j2axZ0.html" rel="bookmark">学习andriod开发之 异步加载图片&lpar;二&rpar;--- 使用其他进度条</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				大家好 我是akira上一节 我们讲到使用AsyncTask 这个类进行异步的下载 主要是涉及到一些图片的更新 这次我们继续上一个demo的改进 . 不知道你是否发现一个问题 上一节我们遗留了两个bug 1 在无网络情况下 点击会崩 咱们说 软件开发最忌讳的就是crash 而这个是在bug解决方案中的一级要解决的 所以这个问题 必须搞定 2 就是我们会发现进度并未更新 而图片是显示完毕了的 3 就是一个扩展 这次我将会带来 daimajia的新库 也是做库小达人的最新作品 NumberProgr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JjLVP4.html" rel="bookmark">IOS开发之异步加载网络图片并缓存本地实现瀑布流（二）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				/* * @brief 图片加载通用函数 * @parma imageName 图片名 */ - (void)imageStartLoading:(NSString *)imageName{ NSURL *url = [NSURL URLWithString:imageName]; if([_fileUtil hasCachedImage:url]){ UIImageView *imageView = [[UIImageView alloc] init]; NSString *path = [_			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KavxY4.html" rel="bookmark" class="title">js javascript 模拟点击 超级链接点击  转</a>
					<div>
						转自:http://mo2g.com/view/42/ 我尝试过多次用jQuery模拟用户点击a标签的功能,但都没有成功,并且困扰了很久.前段时间的一次发呆,冒出了新的想法,于是就动手进行了测试. 先 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0a766R4.html" rel="bookmark" class="title">HDU 4293 &Tab;Groups（区间dp）</a>
					<div>
						HDU 4293 题意:有 n 个人,可任意分成若干组,然后每个人各提供一个信息,表示他们组前面有多少个人,后面有多少个人.问最多有多少个信息是真实的的. 思路: 这道题一开始给我的印象是什么乱七八糟 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLJqEE3.html" rel="bookmark" class="title">将CAGradientLayer用作maskView的遮罩图层</a>
					<div>
						说明 CAGradientLayer可以用作alpha遮罩,供maskView使用,这两种东西都是非常偏门的东西,但是,偏门不代表功能不强大,我们可以用CAGradientLayer制作出非常牛逼的动 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lrmRo4.html" rel="bookmark" class="title">HDU 2274 Magic WisKey</a>
					<div>
						题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2274 Magic WisKey Time Limit: 2000/1000 MS (Java/Othe ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEkbnx3.html" rel="bookmark" class="title">C&num;字符串的不变性</a>
					<div>
						看过一些C#教程的人都应该知道这句话:“在C#中,一旦对字符串对象进行初始化,该字符串对象就不能再被该变“.这句话可用简单的图示来说明: 1.声明变量 string str=&quot;first&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzQaY84.html" rel="bookmark" class="title">函数的一些基本知识</a>
					<div>
						函数:一个具备某种功能的模块,每个函数都有名称,该名称叫做函数名. 参数:函数正常工作需要的额外信息. 返回结果:函数运行完后,得到的结果. 返回类型:返回结果的类型. 函数的思想:分 和 复用 函数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ORdrX0.html" rel="bookmark" class="title">AndroidUI组件之AdapterViewFilpper</a>
					<div>
						package com.gc.adapterviewflipperdemo; /** * 功能:自动播放的图片库 * @author Android将军 */ /* * 1.AdapterViewFi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qawmN3.html" rel="bookmark" class="title">form属性的错误使用</a>
					<div>
						HTML5引入了一些form的新属性,以下是一些使用上的注意事项: 布尔属性 一些多媒体元素和其他元素也具有布尔属性.这里所说的规则也同样适用. 有一些新的form属性是布尔型的,意味着它们只要出现在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGpnyV0.html" rel="bookmark" class="title">Node&period;js中的express框架获取参数</a>
					<div>
						express获取参数有三种方法: req.query  适合 http://localhost:3000/form?num=8888 req.body   适合http://localhost:30 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bqawkM.html" rel="bookmark" class="title">Mysql 5&period;7&period;9源代码安装</a>
					<div>
						groupadd -r mysql &amp;&amp; useradd-r -g mysql -s /bin/false -M mysql yum -y install ncurses-devel  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YRbDO3.html" rel="bookmark" class="title">struts-config&period;xml配置文件详解</a>
					<div>
						(1)最近在学struts,找到一个struts-config.xml的配置说明,分享给大家: &lt;struts-config&gt;是struts的根元素,它主要有8个子元素,DTD定义如下:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0R7DJY3.html" rel="bookmark" class="title">设计模式之中介者模式20170731</a>
					<div>
						行为型设计模式之中介者模式: 一.含义 用一个中介对象封装一系列的对象交互,中介者使各对象不需要显示地相互作用,从而使其耦合松散,而且可以独立地改变它们之间的交互. 同事角色与其他同时角色通信的时候, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmY8pDM.html" rel="bookmark" class="title">126邮箱的格式</a>
					<div>
						自己写的勿喷: &lt;!DOCTYPE html PUBLIC &quot;-//W3C//DTD HTML 4.01//EN&quot; &quot;http://www.w3.org/TR/ht ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzLrGl3.html" rel="bookmark" class="title">Linux常用命令汇总--telnet</a>
					<div>
						telnet命令用于远端登入,测试环境中没有安装telnet,因此就从安装telnet和telnet-server开始. 1.安装方式: yum install -y telnet yum insta ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBxlxK3.html" rel="bookmark" class="title">《NoSQL精粹》读书笔记</a>
					<div>
						NoSQL数据库数据模型的一般分类: 1. 键值数据模型 2. 文档数据模型 3. 列族数据模型 4. 图数据模型 常见NoSQL数据库: Redis, Cassandra, MongoDB, Neo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l7wdZM.html" rel="bookmark" class="title">CheckoutContext</a>
					<div>
						using System; using System.Collections.Generic; using WindowsFormsApplication3.Utility; using Window ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QaPbw4.html" rel="bookmark" class="title">CentOS7，使用tar命令解压缩文件</a>
					<div>
						我们经常会遇到打包成.gz格式的压缩包,这种包不是可执行自动安装包,这种包相当于是个zip包,其安装过程就是手动解压缩.编辑配置文件.配置环境变量的过程.通过以下命令可以加压缩一个gz文件: tar  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qGYqPM.html" rel="bookmark" class="title">转载：安装Ubuntu 15&period;10后要做的事</a>
					<div>
						原文转载于:http://blog.csdn.net/skykingf/article/details/45267517 Ubuntu 15.10发布了,带来了很多新特性,同样也依然带着很多不习惯的东 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49kjPA0.html" rel="bookmark" class="title">Maven相关内容学习笔记一：基本配置和使用</a>
					<div>
						首先必须推荐的这本书&lt;Maven实战&gt; 许晓斌,机械工业出版社 Maven简介 其实使用Maven也有很久时间了,大部分都是别人建好了工程我使用一下,实际上并没有非常详细的使用经验,这次到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBWOAj0.html" rel="bookmark" class="title">MapReduce 实现最小生成树</a>
					<div>
						对应于下面的一个输入图,求出最短距离: 对应与的输入文件在hdfs上面存储的形式如下:制表符分隔 代码如下: package MST; import java.io.IOException; impo ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
